//+------------------------------------------------------------------+
//|                                                   MarketInfo.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <WinUser32.mqh>
#include <stdlib.mqh>


string Currencies[] = { "AED", "AUD", "BHD", "BRL", "CAD", "CHF", "CNY", 
                        "CYP", "CZK", "DKK", "DZD", "EEK", "EGP", "EUR",
                        "GBP", "HKD", "HRK", "HUF", "IDR", "ILS", "INR",
                        "IQD", "IRR", "ISK", "JOD", "JPY", "KRW", "KWD",
                        "LBP", "LTL", "LVL", "LYD", "MAD", "MXN", "MYR",
                        "NOK", "NZD", "OMR", "PHP", "PLN", "QAR", "RON",
                        "RUB", "SAR", "SEK", "SGD", "SKK", "SYP", "THB",
                        "TND", "TRY", "TWD", "USD", "VEB", "XAG", "XAU",
                        "YER", "ZAR", "ALL", "ARS", "BWP", "CCK", "CLP",
                        "CNY", "COP", "CVE", "DOP", "GEL", "GIP", "HKD",
                        "LBR", "LSL", "MTL", "NPR", "PKR", "RUR", "UAH",
                        "XOF", "ZMK" };
                                                                                                                                                                                                                                                
string list[];
int    SymbolCount = 0; 

int init(){
   CreateSymbolList();
   
   int handle = FileOpen(AccountServer() + ".csv", FILE_WRITE|FILE_READ, ';');
   
   if (handle > 0) {
      FileWrite(handle, "Symbol","Low","High","Time","Bid","Ask","Point","Digits","Spread","StopLevel","LotSize","TickValue","TickSize","SwapLong","SwapShort","TradeAllowed","MinLot","LotStep","MaxLot","Freezelevel");   
      FileClose(handle);
   }
}


int CreateSymbolList()
  {
   int CurrencyCount = ArrayRange(Currencies, 0);
   int Loop, SubLoop;
   string TempSymbol;
   for(Loop = 0; Loop < CurrencyCount; Loop++)
       for(SubLoop = 0; SubLoop < CurrencyCount; SubLoop++)
         {
           TempSymbol = Currencies[Loop] + Currencies[SubLoop];
           if(MarketInfo(TempSymbol, MODE_BID) > 0){
               ArrayResize(list, SymbolCount + 1);
               list[SymbolCount] = TempSymbol;
               SymbolCount++;
             }
         }
   return(0);
  }
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start(){
//----
   for (int i = 0; i < ArraySize(list); i++){

   double ModeLow = 0, ModeHigh = 0, ModeTime = 0, ModeBid = 0, ModeAsk = 0, ModePoint = 0;
   double ModeLotSize = 0, ModeTickValue = 0, ModeTickSize = 0, ModeSwapLong = 0, ModeSwapShort = 0;
   double ModeTradeAllowed = 0, ModeMinLot = 0, ModeMaxLot = 0, ModeLotStep = 0;
   int ModeDigits = 0,ModeSpread = 0,ModeStopLevel = 0,ModeFreezelevel = 0; 
   
      ModeLow           = MarketInfo(list[i], MODE_LOW);
      ModeHigh          = MarketInfo(list[i], MODE_HIGH);
      ModeTime          = MarketInfo(list[i], MODE_TIME);
      ModeBid           = MarketInfo(list[i], MODE_BID);
      ModeAsk           = MarketInfo(list[i], MODE_ASK);
      ModePoint         = MarketInfo(list[i], MODE_POINT);
      ModeDigits        = MarketInfo(list[i], MODE_DIGITS);
      ModeSpread        = MarketInfo(list[i], MODE_SPREAD);
      ModeStopLevel     = MarketInfo(list[i], MODE_STOPLEVEL);
      ModeLotSize       = MarketInfo(list[i], MODE_LOTSIZE);
      ModeTickValue     = MarketInfo(list[i], MODE_TICKVALUE);
      ModeTickSize      = MarketInfo(list[i], MODE_TICKSIZE);
      ModeSwapLong      = MarketInfo(list[i], MODE_SWAPLONG);
      ModeSwapShort     = MarketInfo(list[i], MODE_SWAPSHORT);
      ModeTradeAllowed  = MarketInfo(list[i], MODE_TRADEALLOWED);
      ModeMinLot        = MarketInfo(list[i], MODE_MINLOT);
      ModeLotStep       = MarketInfo(list[i], MODE_LOTSTEP);
      ModeMaxLot        = MarketInfo(list[i], MODE_MAXLOT);
      ModeFreezelevel   = MarketInfo(list[i], MODE_FREEZELEVEL);

   int handle = FileOpen(AccountServer() + ".csv", FILE_WRITE|FILE_READ, ';');
   
   if (handle > 0) {
      FileSeek(handle, 0, SEEK_END);
      FileWrite(handle, list[i],ModeLow,ModeHigh,ModeTime,ModeBid,ModeAsk,ModePoint,ModeDigits,ModeSpread,ModeStopLevel,ModeLotSize,ModeTickValue,ModeTickSize,ModeSwapLong,ModeSwapShort,ModeTradeAllowed,ModeMinLot,ModeLotStep,ModeMaxLot,ModeFreezelevel);
      FileClose(handle);
   }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+